<template>
    <div>
        <TableHeader ref="TableHeaderRef" showExport showCustomColumn>
            <template #select>
                <el-form-item label="项目名称">
                    <el-input style="width: 200px" placeholder="请输入项目名称" v-model="tableStore.table.params.projectName"
                        clearable maxlength="32" show-word-limit></el-input>
                </el-form-item>
                <el-form-item label="所在地市">
                    <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所在地市" filterable>
                        <el-option v-for="item in areaOptionList" :key="item.id" :label="item.name"
                            :value="item.name"></el-option>
                    </el-select>
                </el-form-item>
            </template>
            <template #operation>
                <el-button icon="el-icon-Plus" type="primary" @click="addFormModel">新增</el-button>
                <el-button icon="el-icon-Delete" type="primary" @click="deleteEven">删除</el-button>
                <el-button icon="el-icon-Download" type="primary" @click="exportExcelTemplate"  :loading="loading">模版下载</el-button>
                <el-button icon="el-icon-Upload" type="primary" @click="importUserData">批量导入</el-button>
            </template>
        </TableHeader>
        <Table ref="tableRef" :checkbox-config="checkboxConfig" />
        <el-dialog title="详情" width="80%" v-model="dialogShow">
            <DetailInfo :id="userId"></DetailInfo>
        </el-dialog>
        <sensitive-user-popup ref="sensitiveUserPopup" />

        <!-- 查看详情 detail 新增/修改 create-->
        <addForm ref="addForms" @onSubmit="tableStore.index()" openType="create" :submissionControl="false"></addForm>
    </div>
</template>
<script setup lang="ts">
import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useDictData } from '@/stores/dictData'
import DetailInfo from '../../interfere/components/undocumented/detail.vue'
import { downloadSensitiveUserTemplate } from '@/api/supervision-boot/userReport/form'
import SensitiveUserPopup from './sensitiveUserPopup.vue'
import addForm from '@/views/pqs/supervise/interfere/components/undocumented/addForm.vue'
import { deleteUserReport } from '@/api/supervision-boot/delete/index'
import { ElMessage } from 'element-plus'
const dictData = useDictData()
const sensitiveUserPopup = ref()
const TableHeaderRef = ref()
const loading = ref(false)
const areaOptionList = dictData.getBasicData('jibei_area')
const loadLevelOptionList = dictData.getBasicData('load_level')
const powerSupplyInfoOptionList = dictData.getBasicData('supply_condition')
import { useAdminInfo } from '@/stores/adminInfo'
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getSensitiveUserPage',
    publicHeight: 65,
    method: 'POST',
    filename:'敏感及重要用户台账',
    column: [
        {
            width: '60',
            type: 'checkbox'
        },
        {
            title: '序号',
            width: 80,
            formatter: (row: any) => {
                return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
            }
        },
        { field: 'city', title: '所在地市', minWidth: 80 },
        {
            field: 'substation',
            title: '厂站名称',
            minWidth: 100,
            formatter: (row: any) => {
                return row.cellValue ? row.cellValue : '/'
            }
        },
        { field: 'projectName', title: '项目名称', minWidth: 170 },

        // { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },

        {
            field: 'userReportSensitivePO.loadLevel',
            title: '负荷级别',
            minWidth: 170,
            formatter: (row: any) => {
                return loadLevelOptionList.filter(item => item.id === row.cellValue)[0]?.name
            }
        },
        {
            field: 'userReportSensitivePO.powerSupplyInfo',
            title: '供电电源情况',
            minWidth: 170,
            formatter: (row: any) => {
                return powerSupplyInfoOptionList.filter(item => item.id === row.cellValue)[0]?.name
            }
        },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        {
             title: '操作',fixed: 'right',
            minWidth: 150,
         
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '详细信息',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        lookInfo(row.id)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return (
                            (row.city != adminInfo.$state.deptName && row.createBy != adminInfo.$state.id) ||
                            !(row.dataType == 1)
                        )
                    },
                    // disabled: row => {
                    //     return !(row.status == 0)
                    // },
                    click: row => {
                        addForms.value.filterUsers([5, 4, 3, 2, 1, 0])
                        addForms.value.open({
                            title: '编辑',
                            row: row
                        })
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
    },
    exportProcessingData: () => {
          tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.userStatus =
                item.userStatus == 0 ? '可研' : item.userStatus == 1 ? '建设' : item.userStatus == 2 ? '运行' : '退运'
            
            return item
        })
    }
})
tableStore.table.params.city = ''
tableStore.table.params.projectName = ''
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.orgId = adminInfo.$state.deptId
tableStore.table.params.relationUserName = ''
tableStore.table.params.aisFileUpload = ''
const addForms = ref()
const userId = ref()
const dialogShow = ref(false)

const lookInfo = (id: string) => {
    userId.value = id
    dialogShow.value = true
}

provide('tableStore', tableStore)
onMounted(() => {
    tableStore.index()
})
// 禁止点击
const checkboxConfig = reactive({
    checkMethod: ({ row }) => {
        return adminInfo.roleCode.includes('delete_info')
            ? true
            : row.createBy == adminInfo.$state.id && row.status == 0
    }
})
const deleteEven = () => {
    if (tableStore.table.selection.length == 0) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据'
        })
    } else {
        ElMessageBox.confirm('此操作将永久删除, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
    })
        .then(() => {
          
            deleteUserReport(tableStore.table.selection.map(item => item.id)).then(res => {
                ElMessage({
                    type: 'success',
                    message: '删除成功!'
                })
                tableStore.index()
            })
        })

    }
}

// 新增
const addFormModel = () => {
    addForms.value.filterUsers([5, 4, 3, 2, 1, 0])

    addForms.value.open({
        title: '用户档案录入'
    })
}
/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}

//导出模板
const exportExcelTemplate = async () => {
    loading.value = true
  await  downloadSensitiveUserTemplate().then((res: any) => {
        let blob = new Blob([res], {
            type: 'application/vnd.ms-excel'
        })
        const url = window.URL.createObjectURL(blob)
        const link = document.createElement('a')
        link.href = url
        link.download = '敏感及重要用户模板'
        document.body.appendChild(link)
        link.click()
        link.remove()
    })
    await setTimeout(() => {
        loading.value = false
    }, 0)
}

//批量导入用户数据
const importUserData = () => {
    sensitiveUserPopup.value.open('导入敏感及重要用户')
}
</script>
